//+------------------------------------------------------------------+
//|                                                 CandleLength.mq4 |
//|                                                           GumRai |
//|                                                             none |
//+------------------------------------------------------------------+
#property copyright "GumRai"
#property link      "none"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_ORDER
  {
   High_Low,
   Open_Close
  };
#property indicator_chart_window
//--- input parameters
input int      MinLength=25;
input ENUM_ORDER  Range = High_Low;
input color    ArrowColour=clrDodgerBlue;
input int      ArrowSize=2;

string HLorOC;
double PipPoint;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {

   switch(Range)
     {
      case High_Low:
         HLorOC="HighLow";
         break;
      case Open_Close:
         HLorOC="OpenClose";
         break;
     }

   if(Digits==4 || Digits==5)
      PipPoint=0.0001;
   else
   if(Digits==2 || Digits==3)
      PipPoint=0.01;
   else
      PipPoint=Point;

//Alert(HLorOC);
//--- indicator buffers mapping

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   for(int i=ObjectsTotal()-1;i>=0;i--)
     {
      string ObName=ObjectName(i);
      Print(ObName);
      if(StringFind(ObName,"CandleLengthxx",0)!=-1)
         ObjectDelete(ObName);
     }

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---

   double clength;
   int limit=rates_total-prev_calculated+1;
   if(prev_calculated==0)
      limit=rates_total-1;

   for(int index=limit;index>=0;index--)
     {
      if(HLorOC=="HighLow")
         clength=(High[index]-Low[index])/PipPoint;
      else
         clength=(MathAbs(Open[index]-Close[index]))/PipPoint;
      if(clength>=MinLength)
        {
//          string name="CandleLengthxx"+(string)Time[index];
        string name="CandleLengthxx";
         if(ObjectFind(0,name)!=0)
           {
            ObjectCreate(name,OBJ_ARROW_UP,0,Time[index],Low[index]);
            ObjectSet(name,OBJPROP_COLOR,ArrowColour);
            ObjectSet(name,OBJPROP_WIDTH,ArrowSize);
            ObjectSetText(name,"Candle Size "+DoubleToStr(clength,2)+" Pips");
            if(index==0)
               Alert(Symbol()," . "," Candle length exceeds ",MinLength);
           }
         else
           {
            ObjectSetText(name,"Candle Size "+DoubleToStr(clength,2)+" Pips");
            ObjectMove(name,0,Time[index],Low[index]);
           }

        }

     }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+



//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
